<?php

// 作成者: Hirofumi Yokohata
// 作成日: 2024-02-20

require_once '../apikey/config.php';
$apiKey = OPENAI_API_KEY;
$apiUrl = 'https://api.openai.com/v1/chat/completions';

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    // プロンプトの処理
    $userPrompt = filter_input(INPUT_POST, 'userPrompt', FILTER_SANITIZE_STRING);

    if (isset($_FILES['knowledgeBaseFile']) && $_FILES['knowledgeBaseFile']['error'] == UPLOAD_ERR_OK) {
        $file = $_FILES['knowledgeBaseFile'];
        $fileType = $file['type'];
        $fileSize = $file['size'];
        
        // 安全なファイル名を生成
        $safeFileName = uniqid("upload_", true) . ".txt"; // 一意のファイル名を生成
        
        if ($fileType == 'text/plain' && $fileSize <= 1000000) {
            if (move_uploaded_file($file['tmp_name'], "../apifile/" . $safeFileName)) {
                $fileContent = file_get_contents("../apifile/" . $safeFileName);
                $sanitizedContent = htmlspecialchars($fileContent, ENT_QUOTES, 'utf-8');
                $headers = [
                    'Content-Type: application/json',
                    sprintf('Authorization: Bearer %s', $apiKey),
                ];
                $data = [
                    'model' => 'gpt-3.5-turbo',
                    'max_tokens' => 1024, // 例として1024トークンを設定
                    'messages' => [
                        ['role' => 'system', 'content' => 'You are a helpful assistant.'],
                        ['role' => 'user', 'content' => $sanitizedContent . " " . $userPrompt],
                    ],
                ];
                $ch = curl_init($apiUrl);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
                $response = curl_exec($ch);

                if (curl_errno($ch)) {
                    echo 'Error:' . curl_error($ch);
                } else {
                    $responseArray = json_decode($response, true);
                    echo $responseArray['choices'][0]['message']['content'];
                }
                curl_close($ch);
            } else {
                echo "ファイルのアップロードに失敗しました。";
            }
        } else {
            echo "不正なファイルタイプ、またはサイズが大きすぎます。";
        }
    } else {
        echo "ファイルが選択されていません。";
    }
} else {
    echo "不正なリクエストです。";
}
?>

