document.getElementById('promptForm').onsubmit = function(event) {
event.preventDefault();

const formData = new FormData();
formData.append('userPrompt', document.getElementById('userPrompt').value);
formData.append('knowledgeBaseFile', document.getElementById('knowledgeBaseFile').files[0]);

fetch('./chat.php', {
	method: 'POST',
	body: formData,
})
.then(response => response.text())
.then(text => {
	document.getElementById('responseText').innerText = text;
	speak(text);
})
.catch(error => console.error('Error:', error));
};

function speak(text) {
	const utterance = new SpeechSynthesisUtterance(text);
	utterance.lang = 'ja-JP';
	speechSynthesis.speak(utterance);
}